package cn.qqck.kotlin.tools

import java.io.ByteArrayInputStream
import java.security.KeyFactory
import java.security.cert.CertificateFactory
import java.security.spec.PKCS8EncodedKeySpec

object KeyStore {
    fun pem2ks(cert: String, key: String, alias: String, password: String, type: String = "jks"): java.security.KeyStore? = try {
        val j_keystore = java.security.KeyStore.getInstance(type)
        j_keystore.load(null, null)
        j_keystore.setKeyEntry(
            alias,
            KeyFactory.getInstance("RSA").generatePrivate(
                PKCS8EncodedKeySpec(
                    key.replace("-----BEGIN PRIVATE KEY-----", "")
                        .replace("-----END PRIVATE KEY-----", "")
                        .replace("\n", "")
                        .replace(" ", "")
                        .base64()
                )
            ),
            password.toCharArray(),
            CertificateFactory
                .getInstance("X.509")
                .generateCertificates(ByteArrayInputStream(cert.toByteArray()))
                .toTypedArray()
        )
        j_keystore
    } catch (e: Exception) {
        e.printStackTrace()
        null
    }
}
