package cn.qqck.kotlin.tools

/**
 * 将当前Long类型的数值转换为以"元"为单位的金额字符串表示。
 *
 * @param 厘 是否使用厘为单位进行转换。当为true时，将值除以1000；默认false时，将值除以100。
 * @return 转换后的金额字符串，保留两位小数。
 */
fun Long.元(厘: Boolean = false): String {
    return String.format("%.2f", this / (if (厘) 1000.0 else 100.0))
}
